#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
    int idMuzicara;
    char ime[50];
    char prezime[50];
} Muzicar;

typedef struct {
    int idFestivala;
    int godina;
    int idBenda;
    int dan;
} LineupFestivala;

typedef struct {
    int idMuzicara;
    int idBenda;
    char datum1[50];
    char datum2[50];
} SastavBenda;

int dajMiZavrsniDan(LineupFestivala lineups[], int brojLineups, int idFestivala) {
    int max = 0;
    for (int i = 0; i < brojLineups; i++) {
        if (lineups[i].idFestivala == idFestivala) {
            if (lineups[i].dan > max)
                max = lineups[i].dan;
        }
    }

    return max;
}

int main(int argc, char **argv) {
    FILE *f = fopen(argv[1], "r");
    // FILE *f = fopen("muzicari.csv", "r");
    int brojMuzicara = 0;
    Muzicar muzicari[50];
    while (fscanf(f, "%d,%[^,],%s", &muzicari[brojMuzicara].idMuzicara, muzicari[brojMuzicara].ime, muzicari[brojMuzicara].prezime) == 3) {
        // printf("%s %s\n", muzicari[brojMuzicara].ime, muzicari[brojMuzicara].prezime);
        brojMuzicara++;
    }
    fclose(f);

    f = fopen("lineup_festivala.csv", "r");
    int brojLineupFestivala = 0;
    LineupFestivala lineups[50];
    while (fscanf(f, "%d,%d,%d,%d", &lineups[brojLineupFestivala].idFestivala, &lineups[brojLineupFestivala].godina, &lineups[brojLineupFestivala].idBenda, &lineups[brojLineupFestivala].dan) == 4) {
        // printf("%d %d %d %d\n", lineups[brojLineupFestivala].idFestivala, lineups[brojLineupFestivala].godina, lineups[brojLineupFestivala].idBenda, lineups[brojLineupFestivala].dan);
        brojLineupFestivala++;
    }
    fclose(f);

    f = fopen("sastav_benda.csv", "r");
    int brojSastavBenda = 0;
    SastavBenda sastaviBendova[50];
    char delim[5] = "-";
    while (fscanf(f, "%d,%d,%[^,],%s", &sastaviBendova[brojSastavBenda].idMuzicara, &sastaviBendova[brojSastavBenda].idBenda, sastaviBendova[brojSastavBenda].datum1, sastaviBendova[brojSastavBenda].datum2) == 4) {
        char *deo1 = strtok(sastaviBendova[brojSastavBenda].datum1, delim);
        char *deo2 = strtok(sastaviBendova[brojSastavBenda].datum2, delim);

        strcpy(sastaviBendova[brojSastavBenda].datum1, deo1);
        
        if (sastaviBendova[brojSastavBenda].datum2[0] == 'N') {
            strcpy(sastaviBendova[brojSastavBenda].datum2, "2024");
        } else {
            strcpy(sastaviBendova[brojSastavBenda].datum2, deo2);
        }
            
        // printf("%d %d %s %s\n", sastaviBendova[brojSastavBenda].idMuzicara, sastaviBendova[brojSastavBenda].idBenda, sastaviBendova[brojSastavBenda].datum1, sastaviBendova[brojSastavBenda].datum2);
        brojSastavBenda++;
    }
    fclose(f);

    // printf("%d\n", dajMiZavrsniDan(lineups, brojLineupFestivala, 2));

    FILE *out = fopen("trazeniMuzicar.csv", "w");
    for (int i = 0; i < brojMuzicara; i++) {
        int brojNastupa = 0;
        int idMuzicara = 0;
        for (int j = 0; j < brojSastavBenda; i++) {
            if (muzicari[i].idMuzicara == sastaviBendova[j].idMuzicara) {
                // pronasli smo bend za koji svira muzicar
                for (int k = 0; k < brojLineupFestivala; k++) {
                    if (sastaviBendova[j].idBenda == lineups[k].idBenda) {
                        // pronasli smo festival na kojem je svirao muzicar
                        if (atoi(sastaviBendova[j].datum1) <= lineups[k].godina && atoi(sastaviBendova[j].datum2) > lineups[k].godina && lineups[k].dan == dajMiZavrsniDan(lineups, brojLineupFestivala, lineups[k].idFestivala)) {
                            // muzicar je svirao za vreme odrzavanja festivala (bio je u bendu tad) i to je zavrsni dan festivala
                            brojNastupa++;
                            idMuzicara = muzicari[i].idMuzicara;
                        }
                    }
                }
            }
        }
        if (brojNastupa > 0) {
            // muzicar je svirao na zavrsnom danu festivala
            fprintf(out, "%s %s %d\n", muzicari[i].ime, muzicari[i].prezime, brojNastupa);
        }
    }
    fclose(out);

    return 0;
}