#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define MAX_IN_BUFFER 1024

typedef struct sastavbenda{
    int id_muzicara, id_benda, datum_1, datum_2, broj_nastupa_na_poslednjem_danu;
}SastavBenda;

typedef struct lineupfestivala{
    int id_festivala, godina, idBenda, dan;
}LineupFestivala;

typedef struct festivali{
    int idFestivala;
    char naziv[100];
    int poslednji_dan_festivala;
}Festivali;

SastavBenda sastav_benda_model[MAX_IN_BUFFER];
int sastav_benda_counter = 0;

LineupFestivala lineup_festivala_model[MAX_IN_BUFFER];
int lineup_festivala_counter = 0;

Festivali festivali_model[MAX_IN_BUFFER];
int festivali_counter = 0;

void loadSastavBenda(){
    FILE *f;
    char buffer[MAX_IN_BUFFER];
    char *token;

    f = fopen("sastav_benda.csv","r");
    while(fgets(buffer, MAX_IN_BUFFER, f) != NULL){
        token = strtok(buffer, ",");
        sastav_benda_model[sastav_benda_counter].id_muzicara = atoi(token);
        token = strtok(NULL,",");
        sastav_benda_model[sastav_benda_counter].id_benda = atoi(token);
        token = strtok(NULL,",");
        char datum_1[15];
        strcpy(datum_1, token);
        token = strtok(NULL,",");
        char datum_2[15];
        strcpy(datum_2, token);

        token = strtok(datum_1,"-");
        sastav_benda_model[sastav_benda_counter].datum_1 = atoi(token);
        token = strtok(datum_2,"-");
        sastav_benda_model[sastav_benda_counter].datum_2 = atoi(token);
        if(sastav_benda_model[sastav_benda_counter].datum_2 == 0)
            sastav_benda_model[sastav_benda_counter].datum_2 = 2024;
        // printf("%d %d %d %d \n", sastav_benda_model[sastav_benda_counter].id_muzicara, sastav_benda_model[sastav_benda_counter].id_benda, sastav_benda_model[sastav_benda_counter].datum_1, sastav_benda_model[sastav_benda_counter].datum_2 );
        sastav_benda_model[sastav_benda_counter].broj_nastupa_na_poslednjem_danu = 0;
        sastav_benda_counter++;
    }
    fclose(f);
}

void loadLineupFestivala(){
    FILE *f;
    char buffer[MAX_IN_BUFFER];
    char *token;

    f = fopen("lineup_festivala.csv","r");
    while(fgets(buffer, MAX_IN_BUFFER, f) != NULL){
        token = strtok(buffer, ",");
        lineup_festivala_model[lineup_festivala_counter].id_festivala = atoi(token);
        token = strtok(NULL, ",");
        lineup_festivala_model[lineup_festivala_counter].godina = atoi(token);
        token = strtok(NULL, ",");
        lineup_festivala_model[lineup_festivala_counter].idBenda = atoi(token);
        token = strtok(NULL, ",");
        lineup_festivala_model[lineup_festivala_counter].dan = atoi(token);
        // printf("%d %d %d %d \n", lineup_festivala_model[lineup_festivala_counter].id_festivala,
        // lineup_festivala_model[lineup_festivala_counter].godina,
        // lineup_festivala_model[lineup_festivala_counter].idBenda,
        // lineup_festivala_model[lineup_festivala_counter].dan );
        lineup_festivala_counter++;
    }
    fclose(f);
}

int nadjiPoslednjiDanFestivala(int id){
    int max = 0;
    for(int i=0;i<lineup_festivala_counter;i++){
        if(lineup_festivala_model[i].id_festivala == id && lineup_festivala_model[i].dan > max){
            max = lineup_festivala_model[i].dan;
        }
    }
    return max;
}

void loadFestivali(){
    FILE *f;
    char buffer[MAX_IN_BUFFER];
    char *token;

    f = fopen("festivali.csv","r");
    while(fgets(buffer, MAX_IN_BUFFER, f) != NULL){
        token = strtok(buffer, ",");
        festivali_model[festivali_counter].idFestivala = atoi(token);
        token = strtok(NULL, ",");
        strcpy(festivali_model[festivali_counter].naziv, token);

        festivali_model[festivali_counter].poslednji_dan_festivala = nadjiPoslednjiDanFestivala(
            festivali_model[festivali_counter].idFestivala
        );

        festivali_counter ++;
    }
    fclose(f);
}



int main(int argc, char **argv){
    loadSastavBenda();
    loadLineupFestivala();
    loadFestivali();

    for(int i=0; i<sastav_benda_counter; i++){
        for(int j=0;j<lineup_festivala_counter;j++){
            // da li je poslednji dan festivala i da li je taj muzicar svirao
            if(lineup_festivala_model[j].dan == nadjiPoslednjiDanFestivala(lineup_festivala_model[j].id_festivala) &&
            sastav_benda_model[i].datum_1 <= lineup_festivala_model[j].godina && sastav_benda_model[i].datum_2 >= lineup_festivala_model[j].godina
            ){
                sastav_benda_model[i].broj_nastupa_na_poslednjem_danu +=1;
            }
        }
    }
    // u slucaju da ima vise muzicara u sastav_benda sa istim id-em kupimo veci broj dana
    for(int i=0;i<sastav_benda_counter;i++){
        for(int j=0;j<sastav_benda_counter;j++){
            if(sastav_benda_model[i].id_muzicara == sastav_benda_model[j].id_muzicara){
                if(sastav_benda_model[i].broj_nastupa_na_poslednjem_danu > sastav_benda_model[j].broj_nastupa_na_poslednjem_danu){
                    sastav_benda_model[j].broj_nastupa_na_poslednjem_danu = sastav_benda_model[i].broj_nastupa_na_poslednjem_danu;
                }
                else{
                    sastav_benda_model[j].broj_nastupa_na_poslednjem_danu = sastav_benda_model[i].broj_nastupa_na_poslednjem_danu;
                }
            }
        }
    }
    int index_max = 0;
    for(int i=1;i<sastav_benda_counter;i++){
        if(sastav_benda_model[i].broj_nastupa_na_poslednjem_danu > sastav_benda_model[index_max].broj_nastupa_na_poslednjem_danu)
            index_max = i;
    }

    printf("id muzicara: %d \n", sastav_benda_model[index_max].id_muzicara);

}